# -*- coding: utf-8 -*-
#Main zmovie

#Imports_____________________________________________________________________________________________________________________________
import urllib,urllib2,re,xbmcplugin,xbmcgui,sys,urlresolver,xbmc,os,xbmcaddon
from metahandler import metahandlers

from t0mm0.common.addon import Addon
from t0mm0.common.net import Net

try:
     import StorageServer
except:
     import storageserverdummy as StorageServer

import threading

class Thread(threading.Thread):
    def __init__(self, target, *args):
        self._target = target
        self._args = args
        threading.Thread.__init__(self)
    def run(self):
        self._target(*self._args)

#Define common.addon_____________________________________________________________________________________________________________________________
addon_id = 'plugin.video.zpack'
addon = Addon(addon_id, sys.argv)

#Define Cache for favorites_____________________________________________________________________________________________________________________________
cache = StorageServer.StorageServer("zpack", 0)

#Define queries for common.addon_____________________________________________________________________________________________________________________________
mode = addon.queries['mode']
url = addon.queries.get('url', '')
name = addon.queries.get('name', '')
thumb = addon.queries.get('thumb', '')
year = addon.queries.get('year', '')
season = addon.queries.get('season', '')
episode = addon.queries.get('episode', '')
show = addon.queries.get('show', '')
types = addon.queries.get('types', '')
fanart = addon.queries.get('fanart', '')
rmode = addon.queries.get('rmode', '')
imdb_id = addon.queries.get('imdb_id', '')
host = addon.queries.get('host', '')

#Define other needed global variables_____________________________________________________________________________________________________________________________
settings = xbmcaddon.Addon(id=addon_id)
artwork = xbmc.translatePath(os.path.join('special://home','addons',addon_id,'resources','art/'))
grab=metahandlers.MetaData()
net = Net()

def resolvable(url):
     status = False 
     hmf = urlresolver.HostedMediaFile(url)
     if hmf:
          status = True

     return(status)



def getHost(url):
     if '//' not in url and '/' not in url:
         url = '//'+url+'/blank'
     r = re.search('//(.+?)/([0-9a-zA-Z/]+)', url)
     if r:
         hostname =  r.groups()[0]
     else:
         hostname = "NAME UNKNOWN"
     host = hostname

     if 'nosvideo' in url:
          host = 'nosvideo'

     if host.endswith('.com'):
         host = host[:-4]
     if host.endswith('.org'):
         host = host[:-4]
     if host.endswith('.eu'):
         host = host[:-3]
     if host.endswith('.ch'):
         host = host[:-3]
     if host.endswith('.in'):
         host = host[:-3]
     if host.endswith('.es'):
         host = host[:-3]
     if host.endswith('.tv'):
         host = host[:-3]
     if host.endswith('.net'):
         host = host[:-4]
     if host.endswith('.me'):
         host = host[:-3]
     if host.endswith('.ws'):
         host = host[:-3]
     if host.endswith('.sx'):
         host = host[:-3]
     if host.endswith('.co'):
         host = host[:-3]
     if host.endswith('.us'):
         host = host[:-3]
     if host.endswith('.io'):
         host = host[:-3]
     if host.endswith('.tt'):
         host = host[:-3]
     if host.endswith('.cc'):
         host = host[:-3]
     if host.endswith('.to'):
         host = host[:-3]
     if host.startswith('www.'):
         host = host[4:]
     return host


def nameCleaner(name):
          name = name.replace('&#8211;','')
          name = name.replace("&#8217;","")
          name = name.replace("&#039;s","'s")
          return(name)
     
#Functions for handling favorites_____________________________________________________________________________________________________________________________
def addFavorite():
     saved_favs = cache.get('favourites_' + types)
     favs = []
     if saved_favs:
          favs = eval(saved_favs)
          if favs:
               if (name, url ,rmode, thumb, show, year, season, episode) in favs:
                    addon.show_small_popup(title='Item Already In Favorites', msg=name + ' Is Already In Your Favorites', delay=int(5000), image=thumb)
                    return
     favs.append((name, url ,rmode, thumb, show, year, season, episode))         
     cache.set('favourites_' + types, str(favs))
     addon.show_small_popup(title='Item Added To Favorites', msg=name + ' Was Added To Your Favorites', delay=int(5000), image=thumb)

def removeFavorite():
    saved_favs = cache.get('favourites_' + types)
    if saved_favs:
        favs = eval(saved_favs)
        favs.remove((name, url ,rmode, thumb, show, year, season, episode))   
        cache.set('favourites_' + types, str(favs))
        xbmc.executebuiltin("XBMC.Container.Refresh")

def getFavorites(url):
     if url == 'movie':
          saved_favs = cache.get('favourites_' + 'movie')
          if saved_favs:
               favs = sorted(eval(saved_favs), key=lambda fav: fav[1])
               for fav in favs:
                         addMDir(fav[0], fav[1] ,fav[2], fav[3], fav[4], True)
          AUTOVIEW('movies')

#Metadata Function_____________________________________________________________________________________________________________________________     
def getMeta(types,name,year,show,season,episode):
     show_meta = 0
     meta = 0
     if types=='movie':
          meta = grab.get_meta('movie',name,year)
     elif types=='tvshow':
          meta = grab.get_meta('tvshow',name)
     elif types=='episode':
          try:
               show_meta = grab.get_meta('tvshow',show)
          except:
               show_meta = 0
          if show_meta == 0:
               return 0
          else:
               imdb_id = show_meta['imdb_id']
               meta = grab.get_episode_meta(show,imdb_id,season,episode)
     return(meta)



#Standard directory funtion to be used when not doing scrapes on the directory_____________________________________________________________________________________________________________________________
def addDir(name,url,mode,thumb):
     name = nameCleaner(name)
     if thumb == '':
          thumb = artwork + '/main/noepisode.png'
     params = {'url':url, 'mode':mode, 'name':name, 'thumb':thumb, 'year':year, 'types':'movie'}
     addon.add_directory(params, {'title':name}, img= thumb, fanart= artwork + '/main/fanart.jpg')

#Movie directory function to be used when adding a movie, all metadata scrapes and context menu items are handled:name within_____________________________________________________________________________________________________________________________
def addMDir(name,url,mode,thumb,year,isfav):
     name = nameCleaner(name)
     meta = {}
     contextMenuItems = []

     title = re.split('\d\d\d\d',name)

     if title[0] == '':
          title = name
     if settings.getSetting('metadata') == 'true':
          meta = getMeta('movie',title[0],year,'','','')
     year = re.sub('[()]','',year)
     if year == '':
          try:
               year = meta['year']
          except:
               year = ''
     if year == 0:
          year = ''
     if settings.getSetting('metadata') == 'true':

          if year == '':
               meta['title'] = name

          else:
               meta['title'] = name + ' ' + '(' + str(year) + ')'
     
          if thumb == '':
               thumb = meta['cover_url']

          if meta['backdrop_url'] == '':
                  fanart = artwork + '/main/fanart.jpg'
          else:
                  fanart = meta['backdrop_url']
                  
     params = {'url':url, 'mode':mode, 'name':title[0], 'thumb':thumb, 'year':year, 'types':'movie'}

#     if isfav == False:
#          contextMenuItems.append(('Add To zpack Favourites', 'XBMC.RunPlugin(%s)' % addon.build_plugin_url({'url':url, 'mode':'addFavorite', 'name':name, 'thumb':thumb, 'year':year, 'types':'movie', 'rmode':mode})))

#     elif isfav == True:
 #         contextMenuItems.append(('Remove From zpack Favourites', 'XBMC.RunPlugin(%s)' % addon.build_plugin_url({'url':url, 'mode':'removeFavorite', 'name':name, 'thumb':thumb, 'year':year, 'types':'movie', 'rmode':mode})))

     contextMenuItems.append(('Movie Information', 'XBMC.Action(Info)'))
     
     if settings.getSetting('metadata') == 'true':
          addon.add_directory(params, meta, contextMenuItems, img= thumb, fanart=fanart)
     else:
          addon.add_directory(params, {'title':name},contextMenuItems, img=thumb, fanart= artwork + '/main/fanart.jpg')


#Host directory function to be used when adding a file Host, hthumb stands for host thumb and should be grabbed using the 'GETHOSTTHUMB(host)' function before hand
def addHDir(name,url,mode,thumb):
     host = 'play'

     try:
          host = getHost(url)
          if thumb == '':
               thumb = GETHOSTTHUMB(host)
     except:
          pass

     if host == 'play':
          thumb = artwork + '/hosts/play.png'
          
     fanart = artwork + '/main/fanart.jpg'
     name = re.sub('[()]','',name)
     params = {'url':url, 'mode':mode, 'name':name, 'thumb':thumb, 'year':year, 'types':types, 'season':season, 'episode':episode, 'show':show}
     addon.add_directory(params, {'title':host}, img=thumb, fanart=fanart,is_folder=False)


#Returns the host thumbnail so that you can pass it as and argument to the addHDir function__________________________________________
def GETHOSTTHUMB(host):
     if host.endswith('.com'):
          host = host[:-4]
     if host.endswith('.org'):
          host = host[:-4]
     if host.endswith('.eu'):
          host = host[:-3]
     if host.endswith('.ch'):
          host = host[:-3]
     if host.endswith('.in'):
          host = host[:-3]
     if host.endswith('.es'):
          host = host[:-3]
     if host.endswith('.tv'):
          host = host[:-3]
     if host.endswith('.net'):
          host = host[:-4]
     if host.endswith('.me'):
          host = host[:-3]
     if host.endswith('.ws'):
          host = host[:-3]
     if host.endswith('.sx'):
          host = host[:-3]
     if host.startswith('www.'):
             host = host[4:]
     if 'movzap' in host:
          host = 'movzap'
     
     host = artwork + '/hosts/' + host +'.png'
     host = host.lower()
     return(host)

#Function used for resolving video urls before     
def RESOLVE(name,url,thumb):
     meta=0
     try:
          meta = getMeta(types,name,year,show,season,episode)
     except:
          meta=0
     hmf = urlresolver.HostedMediaFile(url)
     host = ''
     if hmf:
          url = urlresolver.resolve(url)
          host = hmf.get_host()
     else:
          url = OTHER_RESOLVERS(url)
             
     params = {'url':url, 'name':name, 'thumb':thumb}
     if meta == 0:
          addon.add_video_item(params, {'title':name}, img=thumb)
          liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=thumb)

     else:
          addon.add_video_item(params, {'title':name}, img=meta['cover_url'])
          liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=meta['cover_url'])
          liz.setInfo('video',infoLabels=meta)

     xbmc.sleep(1000)
     liz.setPath(str(url))
     liz.setProperty("IsPlayable","true")
     xbmcplugin.setResolvedUrl(int(sys.argv[1]), False, liz)




#Sets the desired view type___________________________________________________________________________________________________________     
def AUTOVIEW(content):
        if content:
                xbmcplugin.setContent(int(sys.argv[1]), content)
                if settings.getSetting('auto-view') == 'true':
                        if content == 'movies':
                                xbmc.executebuiltin("Container.SetViewMode(%s)" % settings.getSetting('movies-view'))
                        elif content == 'tvshows':
                                xbmc.executebuiltin("Container.SetViewMode(%s)" % settings.getSetting('shows-view'))
                        elif content == 'episodes':
                                xbmc.executebuiltin("Container.SetViewMode(%s)" % settings.getSetting('episodes-view'))      
                        else:
                                xbmc.executebuiltin("Container.SetViewMode(%s)" % settings.getSetting('default-view'))
                else:
                        xbmc.executebuiltin("Container.SetViewMode(%s)" % settings.getSetting('default-view') )


        
